precision highp float;

varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

uniform float intensity;

void main() {
    lowp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    highp vec4 color;
    if (intensity < 0.){
        lowp float redCurveValue = texture2D(inputImageTexture2, vec2(textureColor.r, 0.0)).r;
        lowp float greenCurveValue = texture2D(inputImageTexture2, vec2(textureColor.g, 0.0)).g;
        lowp float blueCurveValue = texture2D(inputImageTexture2, vec2(textureColor.b, 0.0)).b;
        color = vec4(redCurveValue, greenCurveValue, blueCurveValue, abs(intensity));
    } else if (intensity > 0.){
        lowp float redCurveValue = texture2D(inputImageTexture3, vec2(textureColor.r, 0.0)).r;
        lowp float greenCurveValue = texture2D(inputImageTexture3, vec2(textureColor.g, 0.0)).g;
        lowp float blueCurveValue = texture2D(inputImageTexture3, vec2(textureColor.b, 0.0)).b;
        color = vec4(redCurveValue, greenCurveValue, blueCurveValue, abs(intensity));
    } else {
        color = textureColor;
    }
    gl_FragColor = mix(textureColor, color, color.a);
}