precision mediump float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;

uniform float mGrain;

void main() {
    vec4 res = texture2D(inputImageTexture, textureCoordinate);
    vec3 color = res.rgb;

    float t = 0.0022337;
    float seed = dot(textureCoordinate, vec2(12.9898, 78.233));

    float inv_luma = dot(color, vec3(-1.0/3.0)) + 1.0;
    float variance = (mGrain*mGrain) * pow(inv_luma, 2.);

    float uniform_noise1 = max(fract(sin(seed) * 43758.5453 + t), 0.0001);
    float r = sqrt(-log(uniform_noise1));

    float uniform_noise2 = fract(cos(seed) * 53758.5453 - t);
    float theta = (2.0 * 3.1415927) * uniform_noise2;

    float noise = variance * r * cos(theta) + 0.5;
    float intensity = 1.0;
    float grain = mix(1.0 + intensity,  1.0 - intensity, noise);

    color = color * grain;

    gl_FragColor = vec4(color.rgb, 1.0);
}