varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform lowp float sepia;

const lowp mat4 matrix = mat4(
0.3588, 0.7044, 0.1368, 0.0,
0.2990, 0.5870, 0.1140, 0.0,
0.2392, 0.4696, 0.0912, 0.0,
0.0, 0.0, 0.0, 1.0
);

void main() {
    lowp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    lowp vec4 multiply = textureColor * matrix;

    gl_FragColor = sepia * multiply + (1.0 - sepia) * textureColor;
}