precision mediump float;

uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;

uniform float intensity;

vec4 vignette(vec4 inColor, vec3 vColor, vec2 uv, vec2 center, float start, float end) {
    lowp float d = distance(uv, center);
    lowp float percent = smoothstep(start, end, d);
    return vec4(mix(inColor.rgb, vColor, percent), inColor.a);
}

void main() {
    vec4 source = texture2D(inputImageTexture, textureCoordinate);

    vec2 vCenter = vec2(0.5, 0.5);
    vec3 vColor = (intensity > 0.) ? vec3(0.) : vec3(1.);
    float val = 0.6 - abs(intensity);

    gl_FragColor = vignette(source, vColor, textureCoordinate, vCenter, val, val+0.4);
}